#include "STools.h"
#include <Arduino.h>

/*
<Данная библиотека содержит в себе различные удобные решения для тех или иных задач.
Наименование STools расшифровывается как Smart Tools, что переводится как "Полезные инструменты".
На данный момент библиотека находится в процессе разработки и активно расширяется.
Разработал: Суходолов Михаил      Почта: skaldek@mail.ru
*/


STools::STools();
STools::STools(int pin){
	_PIN = pin;
	pinMode(pin, INPUT_PULLUP);
}
STools::STools(int pin, int samples, int bcoeff){
	_PIN = pin;
	_samples = samples;
	_bcoeff = bcoeff;	
}

String STools::printLink(){

	  if(Serial.available()){
       ip = Serial.readStringUntil('\n');
  Serial.println("Ссылка принята!");

}
return ip;
}

bool STools::isPressed(){
STools::BPress();
return button_flag;
}

bool STools::isHold(){
STools::BPress();
return hold_flag;
}

void STools::BPress(){
button = !digitalRead(_PIN);
if(button == 1 && button_flag == 0 && millis() - lastpresstime > 200){
  button_flag = 1;
  lastpresstime = millis();
}
if(button == 0 && button_flag == 1 ){
  button_flag = 0;
  hold_flag = 0;
}
if(button == 1 && button_flag == 1 && millis() - lastpresstime > 1000){
  hold_flag = 1;
  lastpresstime = millis();
}
}

float STools::tempC(){

for (i=0; i< _samples; i++) {
_samplesarr[i] = analogRead(_PIN);
delay(10);
}

average = 0;
for (i=0; i< _samples; i++) {
average += _samplesarr[i];
}

average /= _samples;
average = 1023 / average - 1;
average = 10000 / average;

temperature = average / 10000;
temperature = log(temperature);
temperature /= _bcoeff;
temperature += 1.0 / (25 + 273.15);
temperature = 1.0 / temperature;
temperature -= 273.15;
return temperature;
}

float STools::tempF(){
	return (STools::tempC() * 9/5) + 32;
}